]> git.ipfire.org Git - people/ms/u-boot.git/blob - MAKEALL
Merge branch 'master' of git://git.denx.de/u-boot-spi
[people/ms/u-boot.git] / MAKEALL
1 #!/bin/bash
2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
4 # errors.
5 #
6 # SPDX-License-Identifier: GPL-2.0+
7
8 usage()
9 {
10 # if exiting with 0, write to stdout, else write to stderr
11 local ret=${1:-0}
12 [ "${ret}" -eq 1 ] && exec 1>&2
13 cat <<-EOF
14 Usage: MAKEALL [options] [--] [boards-to-build]
15
16 Options:
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
21 -b BOARD, --board BOARD Build all boards with board name BOARD
22 -l, --list List all targets to be built
23 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails
25 -C, --check Enable build checking
26 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored
28 -h, --help This help output
29
30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info.
35
36 If no boards are specified, then the default is "powerpc".
37
38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
41 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
42 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "")
44 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./)
46 BUILD_NBUILDS number of parallel targets (default: 1)
47
48 Examples:
49 - build all Power Architecture boards:
50 MAKEALL -a powerpc
51 MAKEALL --arch powerpc
52 MAKEALL powerpc
53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx
59 EOF
60 exit ${ret}
61 }
62
63 SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
65
66 # Option processing based on util-linux-2.13/getopt-parse.bash
67
68 # Note that we use `"$@"' to let each command-line parameter expand to a
69 # separate word. The quotes around `$@' are essential!
70 # We need TEMP as the `eval set --' would nuke the return value of
71 # getopt.
72 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
73 -n 'MAKEALL' -- "$@"`
74
75 [ $? != 0 ] && usage 1
76
77 # Note the quotes around `$TEMP': they are essential!
78 eval set -- "$TEMP"
79
80 SELECTED=''
81 ONLY_LIST=''
82 PRINT_MAINTS=''
83 MAINTAINERS_ONLY=''
84 CONTINUE=''
85 REBUILD_ERRORS=''
86
87 while true ; do
88 case "$1" in
89 -a|--arch)
90 # echo "Option ARCH: argument \`$2'"
91 if [ "$opt_a" ] ; then
92 opt_a="${opt_a%)} || \$2 == \"$2\")"
93 else
94 opt_a="(\$2 == \"$2\")"
95 fi
96 SELECTED='y'
97 shift 2 ;;
98 -c|--cpu)
99 # echo "Option CPU: argument \`$2'"
100 if [ "$opt_c" ] ; then
101 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
102 else
103 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
104 fi
105 SELECTED='y'
106 shift 2 ;;
107 -s|--soc)
108 # echo "Option SoC: argument \`$2'"
109 if [ "$opt_s" ] ; then
110 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
111 else
112 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
113 fi
114 SELECTED='y'
115 shift 2 ;;
116 -v|--vendor)
117 # echo "Option VENDOR: argument \`$2'"
118 if [ "$opt_v" ] ; then
119 opt_v="${opt_v%)} || \$5 == \"$2\")"
120 else
121 opt_v="(\$5 == \"$2\")"
122 fi
123 SELECTED='y'
124 shift 2 ;;
125 -b|--board)
126 # echo "Option BOARD: argument \`$2'"
127 if [ "$opt_b" ] ; then
128 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
129 else
130 # We need to check the 7th field too
131 # for boards whose 6th field is "-"
132 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
133 fi
134 SELECTED='y'
135 shift 2 ;;
136 -C|--check)
137 CHECK='C=1'
138 shift ;;
139 -n|--continue)
140 CONTINUE='y'
141 shift ;;
142 -r|--rebuild-errors)
143 REBUILD_ERRORS='y'
144 shift ;;
145 -l|--list)
146 ONLY_LIST='y'
147 shift ;;
148 -m|--maintainers)
149 ONLY_LIST='y'
150 PRINT_MAINTS='y'
151 MAINTAINERS_ONLY='y'
152 shift ;;
153 -M|--mails)
154 ONLY_LIST='y'
155 PRINT_MAINTS='y'
156 shift ;;
157 -h|--help)
158 usage ;;
159 --)
160 shift ; break ;;
161 *)
162 echo "Internal error!" >&2 ; exit 1 ;;
163 esac
164 done
165 # echo "Remaining arguments:"
166 # for arg do echo '--> '"\`$arg'" ; done
167
168 FILTER="\$1 !~ /^#/"
169 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
170 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
171 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
172 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
173 [ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
174
175 if [ "$SELECTED" ] ; then
176 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
177
178 # Make sure some boards from boards.cfg are actually found
179 if [ -z "$SELECTED" ] ; then
180 echo "Error: No boards selected, invalid arguments"
181 exit 1
182 fi
183 fi
184
185 #########################################################################
186
187 # Print statistics when we exit
188 trap exit 1 2 3 15
189 trap print_stats 0
190
191 # Determine number of CPU cores if no default was set
192 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
193
194 if [ "$BUILD_NCPUS" -gt 1 ]
195 then
196 JOBS="-j $((BUILD_NCPUS + 1))"
197 else
198 JOBS=""
199 fi
200
201 if [ "${MAKEALL_LOGDIR}" ] ; then
202 LOG_DIR=${MAKEALL_LOGDIR}
203 else
204 LOG_DIR="LOG"
205 fi
206
207 : ${BUILD_NBUILDS:=1}
208 BUILD_MANY=0
209
210 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
211 BUILD_MANY=1
212 : ${BUILD_DIR:=./build}
213 mkdir -p "${BUILD_DIR}/ERR"
214 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
215 fi
216
217 : ${BUILD_DIR:=.}
218
219 OUTPUT_PREFIX="${BUILD_DIR}"
220
221 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
222 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
223 find "${LOG_DIR}/" -type f -exec rm -f {} +
224 fi
225
226 LIST=""
227
228 # Keep track of the number of builds and errors
229 ERR_CNT=0
230 ERR_LIST=""
231 WRN_CNT=0
232 WRN_LIST=""
233 TOTAL_CNT=0
234 SKIP_CNT=0
235 CURRENT_CNT=0
236 OLDEST_IDX=1
237 RC=0
238
239 # Helper funcs for parsing boards.cfg
240 targets_by_field()
241 {
242 field=$1
243 regexp=$2
244
245 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
246 boards.cfg
247 }
248
249 targets_by_arch() { targets_by_field 2 "$@" ; }
250 targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
251 targets_by_soc() { targets_by_field 4 "$@" ; }
252
253 #########################################################################
254 ## MPC5xx Systems
255 #########################################################################
256
257 LIST_5xx="$(targets_by_cpu mpc5xx)"
258
259 #########################################################################
260 ## MPC5xxx Systems
261 #########################################################################
262
263 LIST_5xxx="$(targets_by_cpu mpc5xxx)"
264
265 #########################################################################
266 ## MPC512x Systems
267 #########################################################################
268
269 LIST_512x="$(targets_by_cpu mpc512x)"
270
271 #########################################################################
272 ## MPC8xx Systems
273 #########################################################################
274
275 LIST_8xx="$(targets_by_cpu mpc8xx)"
276
277 #########################################################################
278 ## PPC4xx Systems
279 #########################################################################
280
281 LIST_4xx="$(targets_by_cpu ppc4xx)"
282
283 #########################################################################
284 ## MPC824x Systems
285 #########################################################################
286
287 LIST_824x="$(targets_by_cpu mpc824x)"
288
289 #########################################################################
290 ## MPC8260 Systems (includes 8250, 8255 etc.)
291 #########################################################################
292
293 LIST_8260="$(targets_by_cpu mpc8260)"
294
295 #########################################################################
296 ## MPC83xx Systems (includes 8349, etc.)
297 #########################################################################
298
299 LIST_83xx="$(targets_by_cpu mpc83xx)"
300
301 #########################################################################
302 ## MPC85xx Systems (includes 8540, 8560 etc.)
303 #########################################################################
304
305 LIST_85xx="$(targets_by_cpu mpc85xx)"
306
307 #########################################################################
308 ## MPC86xx Systems
309 #########################################################################
310
311 LIST_86xx="$(targets_by_cpu mpc86xx)"
312
313 #########################################################################
314 ## 74xx/7xx Systems
315 #########################################################################
316
317 LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)"
318
319 #########################################################################
320 ## PowerPC groups
321 #########################################################################
322
323 LIST_TSEC=" \
324 ${LIST_83xx} \
325 ${LIST_85xx} \
326 ${LIST_86xx} \
327 "
328
329 LIST_powerpc=" \
330 ${LIST_5xx} \
331 ${LIST_512x} \
332 ${LIST_5xxx} \
333 ${LIST_8xx} \
334 ${LIST_824x} \
335 ${LIST_8260} \
336 ${LIST_83xx} \
337 ${LIST_85xx} \
338 ${LIST_86xx} \
339 ${LIST_4xx} \
340 ${LIST_74xx_7xx}\
341 "
342
343 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
344 # still using "ppc" instead of "powerpc"
345 LIST_ppc=" \
346 ${LIST_powerpc} \
347 "
348
349 #########################################################################
350 ## StrongARM Systems
351 #########################################################################
352
353 LIST_SA="$(targets_by_cpu sa1100)"
354
355 #########################################################################
356 ## ARM7 Systems
357 #########################################################################
358
359 LIST_ARM7="$(targets_by_cpu arm720t)"
360
361 #########################################################################
362 ## ARM9 Systems
363 #########################################################################
364
365 LIST_ARM9="$(targets_by_cpu arm920t) \
366 $(targets_by_cpu arm926ejs) \
367 $(targets_by_cpu arm946es) \
368 "
369
370 #########################################################################
371 ## ARM11 Systems
372 #########################################################################
373 LIST_ARM11="$(targets_by_cpu arm1136) \
374 $(targets_by_cpu arm1176) \
375 "
376
377 #########################################################################
378 ## ARMV7 Systems
379 #########################################################################
380
381 LIST_ARMV7="$(targets_by_cpu armv7)"
382
383 #########################################################################
384 ## ARMV8 Systems
385 #########################################################################
386
387 LIST_ARMV8="$(targets_by_cpu armv8)"
388
389 #########################################################################
390 ## AT91 Systems
391 #########################################################################
392
393 LIST_at91="$(targets_by_soc at91)"
394
395 #########################################################################
396 ## Xscale Systems
397 #########################################################################
398
399 LIST_pxa="$(targets_by_cpu pxa)"
400
401 #########################################################################
402 ## SPEAr Systems
403 #########################################################################
404
405 LIST_spear="$(targets_by_soc spear)"
406
407 #########################################################################
408 ## ARM groups
409 #########################################################################
410
411 LIST_arm="$(targets_by_arch arm | \
412 for ARMV8_TARGET in $LIST_ARMV8; \
413 do sed "/$ARMV8_TARGET/d"; \
414 done) \
415 "
416
417 #########################################################################
418 ## MIPS Systems (default = big endian)
419 #########################################################################
420
421 LIST_mips4kc=" \
422 incaip \
423 incaip_100MHz \
424 incaip_133MHz \
425 incaip_150MHz \
426 qemu_mips \
427 vct_platinum \
428 vct_platinum_small \
429 vct_platinum_onenand \
430 vct_platinum_onenand_small \
431 vct_platinumavc \
432 vct_platinumavc_small \
433 vct_platinumavc_onenand \
434 vct_platinumavc_onenand_small \
435 vct_premium \
436 vct_premium_small \
437 vct_premium_onenand \
438 vct_premium_onenand_small \
439 "
440
441 LIST_au1xx0=" \
442 dbau1000 \
443 dbau1100 \
444 dbau1500 \
445 dbau1550 \
446 "
447
448 LIST_mips=" \
449 ${LIST_mips4kc} \
450 ${LIST_mips5kc} \
451 ${LIST_au1xx0} \
452 "
453
454 #########################################################################
455 ## MIPS Systems (little endian)
456 #########################################################################
457
458 LIST_au1xx0_el=" \
459 dbau1550_el \
460 pb1000 \
461 "
462 LIST_mips_el=" \
463 ${LIST_au1xx0_el} \
464 "
465 #########################################################################
466 ## OpenRISC Systems
467 #########################################################################
468
469 LIST_openrisc="$(targets_by_arch openrisc)"
470
471 #########################################################################
472 ## x86 Systems
473 #########################################################################
474
475 LIST_x86="$(targets_by_arch x86)"
476
477 #########################################################################
478 ## Nios-II Systems
479 #########################################################################
480
481 LIST_nios2="$(targets_by_arch nios2)"
482
483 #########################################################################
484 ## MicroBlaze Systems
485 #########################################################################
486
487 LIST_microblaze="$(targets_by_arch microblaze)"
488
489 #########################################################################
490 ## ColdFire Systems
491 #########################################################################
492
493 LIST_m68k="$(targets_by_arch m68k)"
494 LIST_coldfire=${LIST_m68k}
495
496 #########################################################################
497 ## AVR32 Systems
498 #########################################################################
499
500 LIST_avr32="$(targets_by_arch avr32)"
501
502 #########################################################################
503 ## Blackfin Systems
504 #########################################################################
505
506 LIST_blackfin="$(targets_by_arch blackfin)"
507
508 #########################################################################
509 ## SH Systems
510 #########################################################################
511
512 LIST_sh2="$(targets_by_cpu sh2)"
513 LIST_sh3="$(targets_by_cpu sh3)"
514 LIST_sh4="$(targets_by_cpu sh4)"
515
516 LIST_sh="$(targets_by_arch sh)"
517
518 #########################################################################
519 ## SPARC Systems
520 #########################################################################
521
522 LIST_sparc="$(targets_by_arch sparc)"
523
524 #########################################################################
525 ## NDS32 Systems
526 #########################################################################
527
528 LIST_nds32="$(targets_by_arch nds32)"
529
530 #########################################################################
531 ## ARC Systems
532 #########################################################################
533
534 LIST_arc="$(targets_by_arch arc)"
535
536 #-----------------------------------------------------------------------
537
538 get_target_location() {
539 local target=$1
540 local BOARD_NAME=""
541 local CONFIG_NAME=""
542 local board=""
543 local vendor=""
544
545 # Automatic mode
546 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
547 if [ -z "${line}" ] ; then echo "" ; return ; fi
548
549 set ${line}
550
551 CONFIG_NAME="${7%_config}"
552
553 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_config}"
554
555 if [ $# -gt 5 ]; then
556 if [ "$6" = "-" ] ; then
557 board=${BOARD_NAME}
558 else
559 board="$6"
560 fi
561 fi
562
563 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
564 [ $# -gt 6 ] && [ "$8" != "-" ] && {
565 tmp="${8%:*}"
566 if [ "$tmp" ] ; then
567 CONFIG_NAME="$tmp"
568 fi
569 }
570
571 # Assign board directory to BOARDIR variable
572 if [ "${vendor}" == "-" ] ; then
573 BOARDDIR=${board}
574 else
575 BOARDDIR=${vendor}/${board}
576 fi
577
578 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
579 }
580
581 get_target_maintainers() {
582 local name=`echo $1 | cut -d : -f 3`
583
584 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
585 if [ -z "${line}" ]; then
586 echo ""
587 return ;
588 fi
589
590 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
591 [ "$mails" == "-" ] && mails=""
592 echo "$mails"
593 }
594
595 get_target_arch() {
596 local target=$1
597
598 # Automatic mode
599 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
600
601 if [ -z "${line}" ] ; then echo "" ; return ; fi
602
603 set ${line}
604 echo "$2"
605 }
606
607 list_target() {
608 if [ "$PRINT_MAINTS" != 'y' ] ; then
609 echo "$1"
610 return
611 fi
612
613 echo -n "$1:"
614
615 local loc=`get_target_location $1`
616
617 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
618
619 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
620
621 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
622
623 local dir=`echo ${loc} | cut -d ":" -f 2`
624 local cfg=`echo ${loc} | cut -d ":" -f 1`
625 local git_result=`git log --format=%aE board/${dir} \
626 include/configs/${cfg}.h | grep "@"`
627 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
628 head -n 3`
629 local git_result_top=`echo ${git_result} | tr " " "\n" | \
630 sort | uniq -c | sort -nr | head -n 3 | \
631 sed "s/^ \+[0-9]\+ \+//"`
632
633 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
634 sort -u | tr "\n" " " | sed "s/ $//" ;
635 else
636 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
637 sed "s/ $//" ;
638 fi
639
640 echo ""
641 }
642
643 # Each finished build will have a file called ${donep}${n},
644 # where n is the index of the build. Each build
645 # we've already noted as finished will have ${skipp}${n}.
646 # The code managing the build process will use this information
647 # to ensure that only BUILD_NBUILDS builds are in flight at once
648 donep="${LOG_DIR}/._done_"
649 skipp="${LOG_DIR}/._skip_"
650
651 build_target_killed() {
652 echo "Aborted $target build."
653 # Remove the logs for this board since it was aborted
654 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
655 exit
656 }
657
658 build_target() {
659 target=$1
660 build_idx=$2
661
662 if [ "$ONLY_LIST" == 'y' ] ; then
663 list_target ${target}
664 return
665 fi
666
667 if [ $BUILD_MANY == 1 ] ; then
668 output_dir="${OUTPUT_PREFIX}/${target}"
669 mkdir -p "${output_dir}"
670 trap build_target_killed TERM
671 else
672 output_dir="${OUTPUT_PREFIX}"
673 fi
674
675 target_arch=$(get_target_arch ${target})
676 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
677 if [ "${cross_toolchain}" ] ; then
678 MAKE="make CROSS_COMPILE=${cross_toolchain}"
679 elif [ "${CROSS_COMPILE}" ] ; then
680 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
681 else
682 MAKE=make
683 fi
684
685 if [ "${output_dir}" != "." ] ; then
686 MAKE="${MAKE} O=${output_dir}"
687 fi
688
689 ${MAKE} distclean >/dev/null
690 ${MAKE} -s ${target}_config
691
692 ${MAKE} ${JOBS} ${CHECK} all \
693 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
694
695 # Check for 'make' errors
696 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
697 RC=1
698 fi
699
700 if [ $BUILD_MANY == 1 ] ; then
701 trap - TERM
702
703 ${MAKE} -s clean
704
705 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
706 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
707 else
708 rm ${LOG_DIR}/${target}.ERR
709 fi
710 else
711 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
712 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
713 : $(( ERR_CNT += 1 ))
714 ERR_LIST="${ERR_LIST} $target"
715 else
716 : $(( WRN_CNT += 1 ))
717 WRN_LIST="${WRN_LIST} $target"
718 fi
719 else
720 rm ${LOG_DIR}/${target}.ERR
721 fi
722 fi
723
724 OBJS=${output_dir}/u-boot
725 if [ -e ${output_dir}/spl/u-boot-spl ]; then
726 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
727 fi
728
729 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
730
731 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
732
733 touch "${donep}${build_idx}"
734 }
735
736 manage_builds() {
737 search_idx=${OLDEST_IDX}
738 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
739
740 while true; do
741 if [ -e "${donep}${search_idx}" ] ; then
742 : $(( CURRENT_CNT-- ))
743 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
744 : $(( OLDEST_IDX++ ))
745
746 # Only want to count it once
747 rm -f "${donep}${search_idx}"
748 touch "${skipp}${search_idx}"
749 elif [ -e "${skipp}${search_idx}" ] ; then
750 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
751 : $(( OLDEST_IDX++ ))
752 fi
753 : $(( search_idx++ ))
754 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
755 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
756 search_idx=${OLDEST_IDX}
757 sleep 1
758 else
759 break
760 fi
761 fi
762 done
763 }
764
765 build_targets() {
766 for t in "$@" ; do
767 # If a LIST_xxx var exists, use it. But avoid variable
768 # expansion in the eval when a board name contains certain
769 # characters that the shell interprets.
770 case ${t} in
771 *[-+=]*) list= ;;
772 *) list=$(eval echo '${LIST_'$t'}') ;;
773 esac
774 if [ -n "${list}" ] ; then
775 build_targets ${list}
776 else
777 : $((TOTAL_CNT += 1))
778 : $((CURRENT_CNT += 1))
779 rm -f "${donep}${TOTAL_CNT}"
780 rm -f "${skipp}${TOTAL_CNT}"
781 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
782 : $((SKIP_CNT += 1))
783 touch "${donep}${TOTAL_CNT}"
784 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
785 : $((SKIP_CNT += 1))
786 touch "${donep}${TOTAL_CNT}"
787 else
788 if [ $BUILD_MANY == 1 ] ; then
789 build_target ${t} ${TOTAL_CNT} &
790 else
791 CUR_TGT="${t}"
792 build_target ${t} ${TOTAL_CNT}
793 CUR_TGT=''
794 fi
795 fi
796 fi
797
798 # We maintain a running count of all the builds we have done.
799 # Each finished build will have a file called ${donep}${n},
800 # where n is the index of the build. Each build
801 # we've already noted as finished will have ${skipp}${n}.
802 # We track the current index via TOTAL_CNT, and the oldest
803 # index. When we exceed the maximum number of parallel builds,
804 # We look from oldest to current for builds that have completed,
805 # and update the current count and oldest index as appropriate.
806 # If we've gone through the entire list, wait a second, and
807 # reprocess the entire list until we find a build that has
808 # completed
809 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
810 manage_builds
811 fi
812 done
813 }
814
815 #-----------------------------------------------------------------------
816
817 kill_children() {
818 local OS=$(uname -s)
819 local children=""
820 case "${OS}" in
821 "Darwin")
822 # Mac OS X is known to have BSD style ps
823 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
824 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
825 ;;
826 *)
827 # everything else tries the GNU style
828 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
829 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
830 ;;
831 esac
832
833 kill $children 2> /dev/null
834 wait $children 2> /dev/null
835
836 exit
837 }
838
839 print_stats() {
840 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
841
842 # Only count boards that completed
843 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
844
845 rm -f ${donep}* ${skipp}*
846
847 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
848 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
849 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
850 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
851 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
852 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
853 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
854 else
855 # Remove the logs for any board that was interrupted
856 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
857 fi
858
859 : $((TOTAL_CNT -= ${SKIP_CNT}))
860 echo ""
861 echo "--------------------- SUMMARY ----------------------------"
862 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
863 echo "Boards skipped: ${SKIP_CNT}"
864 fi
865 echo "Boards compiled: ${TOTAL_CNT}"
866 if [ ${ERR_CNT} -gt 0 ] ; then
867 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
868 fi
869 if [ ${WRN_CNT} -gt 0 ] ; then
870 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
871 fi
872 echo "----------------------------------------------------------"
873
874 if [ $BUILD_MANY == 1 ] ; then
875 kill_children
876 fi
877
878 exit $RC
879 }
880
881 #-----------------------------------------------------------------------
882
883 # Build target groups selected by options, plus any command line args
884 set -- ${SELECTED} "$@"
885 # run PowerPC by default
886 [ $# = 0 ] && set -- powerpc
887 build_targets "$@"
888 wait